Index: aclocal/enable-rtemsbsp.m4
===================================================================
--- aclocal/enable-rtemsbsp.m4	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ aclocal/enable-rtemsbsp.m4	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -43,4 +43,5 @@
 if test x"$multilib" = x"no"; then
   RTEMS_ENV_RTEMSBSP
+  RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
 else
   rtems_cv_RTEMS_BSP="multilib"
Index: c/src/exec/configure.in
===================================================================
--- c/src/exec/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -32,6 +32,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
 RTEMS_CHECK_MULTIPROCESSING(RTEMS_BSP)
 RTEMS_CHECK_POSIX_API(RTEMS_BSP)
Index: c/src/exec/itron/configure.in
===================================================================
--- c/src/exec/itron/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/itron/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -27,6 +27,4 @@
 RTEMS_CANONICALIZE_TOOLS
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
 RTEMS_CHECK_MULTIPROCESSING(RTEMS_BSP)
 RTEMS_CHECK_ITRON_API(RTEMS_BSP)
Index: c/src/exec/posix/configure.in
===================================================================
--- c/src/exec/posix/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/posix/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -27,6 +27,4 @@
 RTEMS_CANONICALIZE_TOOLS
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
 RTEMS_CHECK_MULTIPROCESSING(RTEMS_BSP)
 RTEMS_CHECK_POSIX_API(RTEMS_BSP)
Index: c/src/exec/score/cpu/a29k/configure.in
===================================================================
--- c/src/exec/score/cpu/a29k/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/a29k/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/h8300/configure.in
===================================================================
--- c/src/exec/score/cpu/h8300/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/h8300/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/hppa1.1/configure.in
===================================================================
--- c/src/exec/score/cpu/hppa1.1/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/hppa1.1/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/i386/configure.in
===================================================================
--- c/src/exec/score/cpu/i386/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/i386/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/i960/configure.in
===================================================================
--- c/src/exec/score/cpu/i960/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/i960/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/m68k/configure.in
===================================================================
--- c/src/exec/score/cpu/m68k/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/m68k/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/mips/configure.in
===================================================================
--- c/src/exec/score/cpu/mips/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/mips/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/mips64orion/configure.in
===================================================================
--- c/src/exec/score/cpu/mips64orion/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/mips64orion/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/no_cpu/configure.in
===================================================================
--- c/src/exec/score/cpu/no_cpu/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/no_cpu/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/powerpc/configure.in
===================================================================
--- c/src/exec/score/cpu/powerpc/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/powerpc/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/sh/configure.in
===================================================================
--- c/src/exec/score/cpu/sh/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/sh/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/sparc/configure.in
===================================================================
--- c/src/exec/score/cpu/sparc/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/sparc/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CHECK_NEWLIB
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 # Explicitly list all Makefiles here
 AC_OUTPUT( 
Index: c/src/exec/score/cpu/unix/configure.in
===================================================================
--- c/src/exec/score/cpu/unix/configure.in	(revision dc39377e5347f38f4abe3a97103e56af656f3a23)
+++ c/src/exec/score/cpu/unix/configure.in	(revision 256cbecf68fcde4aff86a6f1c44b7784cb9f36ae)
@@ -25,7 +25,4 @@
 RTEMS_CANONICALIZE_TOOLS
 
-# Check if there is custom/*.cfg for this BSP
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-
 RTEMS_CHECK_NEWLIB
 RTEMS_CHECK_MULTIPROCESSING(RTEMS_BSP)