Index: testsuites/psxtmtests/ChangeLog
===================================================================
--- testsuites/psxtmtests/ChangeLog	(revision 06a81399b8a5a57cddb48b69c87e2d7ff2b2a305)
+++ testsuites/psxtmtests/ChangeLog	(revision 257d8fde7760e26db7d4ed986d01225327302d2e)
@@ -1,2 +1,22 @@
+2011-12-13	Ralf CorsÃ©pius <ralf.corsepius@rtems.org>
+
+	* psxtmbarrier01/init.c: Make benchmark_pthread_barrier_init,
+	benchmark_pthread_barrier_destroy static.
+	* psxtmkey01/init.c: Make benchmark_pthread_key_create,
+	benchmark_pthread_key_delete static.
+	* psxtmrwlock01/init.c: Make benchmark_pthread_rwlock_init,
+	benchmark_pthread_rwlock_rdlock, benchmark_pthread_rwlock_unlock,
+	benchmark_pthread_rwlock_tryrdlock,
+	benchmark_pthread_rwlock_timedrdlock,
+	benchmark_pthread_rwlock_wrlock,
+	benchmark_pthread_rwlock_trywrlock,
+	benchmark_pthread_rwlock_timedwrlock,
+	benchmark_pthread_rwlock_destroy static.
+	* psxtmsem01/init.c: Make benchmark_sem_init,
+	benchmark_sem_destroy, benchmark_sem_open, benchmark_sem_close,
+	benchmark_sem_unlink, benchmark_sem_open_second,
+	benchmark_sem_close_second static.
+	* psxtmthread01/init.c: Make benchmark_pthread_create static.
+
 2011-12-08	Joel Sherrill <joel.sherrill@oarcorp.com>
 
Index: testsuites/psxtmtests/psxtmbarrier01/init.c
===================================================================
--- testsuites/psxtmtests/psxtmbarrier01/init.c	(revision 06a81399b8a5a57cddb48b69c87e2d7ff2b2a305)
+++ testsuites/psxtmtests/psxtmbarrier01/init.c	(revision 257d8fde7760e26db7d4ed986d01225327302d2e)
@@ -21,5 +21,5 @@
 pthread_barrier_t   barrier;
 
-void benchmark_pthread_barrier_init(void)
+static void benchmark_pthread_barrier_init(void)
 {
   benchmark_timer_t end_time;
@@ -47,5 +47,5 @@
 }
 
-void benchmark_pthread_barrier_destroy(void)
+static void benchmark_pthread_barrier_destroy(void)
 {
   benchmark_timer_t end_time;
Index: testsuites/psxtmtests/psxtmkey01/init.c
===================================================================
--- testsuites/psxtmtests/psxtmkey01/init.c	(revision 06a81399b8a5a57cddb48b69c87e2d7ff2b2a305)
+++ testsuites/psxtmtests/psxtmkey01/init.c	(revision 257d8fde7760e26db7d4ed986d01225327302d2e)
@@ -22,5 +22,5 @@
 pthread_key_t Key;
 
-void benchmark_pthread_key_create(void)
+static void benchmark_pthread_key_create(void)
 {
   benchmark_timer_t end_time;
@@ -42,5 +42,5 @@
 }
 
-void benchmark_pthread_key_delete(void)
+static void benchmark_pthread_key_delete(void)
 {
   benchmark_timer_t end_time;
Index: testsuites/psxtmtests/psxtmrwlock01/init.c
===================================================================
--- testsuites/psxtmtests/psxtmrwlock01/init.c	(revision 06a81399b8a5a57cddb48b69c87e2d7ff2b2a305)
+++ testsuites/psxtmtests/psxtmrwlock01/init.c	(revision 257d8fde7760e26db7d4ed986d01225327302d2e)
@@ -21,5 +21,5 @@
 pthread_rwlock_t     rwlock;
 
-void benchmark_pthread_rwlock_init(void)
+static void benchmark_pthread_rwlock_init(void)
 {
   benchmark_timer_t end_time;
@@ -43,5 +43,5 @@
 }
 
-void benchmark_pthread_rwlock_rdlock(void)
+static void benchmark_pthread_rwlock_rdlock(void)
 {
   benchmark_timer_t end_time;
@@ -63,5 +63,5 @@
 }
 
-void benchmark_pthread_rwlock_unlock(int print)
+static void benchmark_pthread_rwlock_unlock(int print)
 {
   benchmark_timer_t end_time;
@@ -83,5 +83,5 @@
 }
 
-void benchmark_pthread_rwlock_tryrdlock(void)
+static void benchmark_pthread_rwlock_tryrdlock(void)
 {
   benchmark_timer_t end_time;
@@ -111,5 +111,5 @@
 }
 
-void benchmark_pthread_rwlock_timedrdlock(void)
+static void benchmark_pthread_rwlock_timedrdlock(void)
 {
   benchmark_timer_t end_time;
@@ -131,5 +131,5 @@
 }
 
-void benchmark_pthread_rwlock_wrlock(void)
+static void benchmark_pthread_rwlock_wrlock(void)
 {
   benchmark_timer_t end_time;
@@ -151,5 +151,5 @@
 }
 
-void benchmark_pthread_rwlock_trywrlock(void)
+static void benchmark_pthread_rwlock_trywrlock(void)
 {
   benchmark_timer_t end_time;
@@ -180,5 +180,5 @@
 }
 
-void benchmark_pthread_rwlock_timedwrlock(void)
+static void benchmark_pthread_rwlock_timedwrlock(void)
 {
   benchmark_timer_t end_time;
@@ -199,5 +199,5 @@
 }
 
-void benchmark_pthread_rwlock_destroy(void)
+static void benchmark_pthread_rwlock_destroy(void)
 {
   benchmark_timer_t end_time;
Index: testsuites/psxtmtests/psxtmsem01/init.c
===================================================================
--- testsuites/psxtmtests/psxtmsem01/init.c	(revision 06a81399b8a5a57cddb48b69c87e2d7ff2b2a305)
+++ testsuites/psxtmtests/psxtmsem01/init.c	(revision 257d8fde7760e26db7d4ed986d01225327302d2e)
@@ -28,5 +28,5 @@
 sem_t           *n_sem2;
 
-void benchmark_sem_init(void)
+static void benchmark_sem_init(void)
 {
   benchmark_timer_t end_time;
@@ -47,5 +47,5 @@
 }
 
-void benchmark_sem_destroy(void)
+static void benchmark_sem_destroy(void)
 {
   benchmark_timer_t end_time;
@@ -66,5 +66,5 @@
 }
 
-void benchmark_sem_open(bool report_time)
+static void benchmark_sem_open(bool report_time)
 {
   benchmark_timer_t end_time;
@@ -85,5 +85,5 @@
 }
 
-void benchmark_sem_close(bool report_time)
+static void benchmark_sem_close(bool report_time)
 {
   benchmark_timer_t end_time;
@@ -106,5 +106,5 @@
 }
 
-void benchmark_sem_unlink(const char *message)
+static void benchmark_sem_unlink(const char *message)
 {
   benchmark_timer_t end_time;
@@ -125,5 +125,5 @@
 }
 
-void benchmark_sem_open_second(void)
+static void benchmark_sem_open_second(void)
 {
   benchmark_timer_t end_time;
@@ -142,5 +142,5 @@
 }
 
-void benchmark_sem_close_second(void)
+static void benchmark_sem_close_second(void)
 {
   benchmark_timer_t end_time;
Index: testsuites/psxtmtests/psxtmthread01/init.c
===================================================================
--- testsuites/psxtmtests/psxtmthread01/init.c	(revision 06a81399b8a5a57cddb48b69c87e2d7ff2b2a305)
+++ testsuites/psxtmtests/psxtmthread01/init.c	(revision 257d8fde7760e26db7d4ed986d01225327302d2e)
@@ -31,5 +31,5 @@
 
 
-void benchmark_pthread_create(
+static void benchmark_pthread_create(
   int    iteration,
   void  *argument